/*
* draftgui-v1.77
* In this version the names of the sets are read from "menus.txt - @EXPANSIONNAMES" and fed into the GUI. Then there is the file "draft_selected_sets.txt" used
* for the communication between the draft and the GUI. when the draftgui is invoked after the player selects the sets and once he presses the "CLOSE" button
* the ID of each selected set is written in "draft_selected_sets.txt" one at a row. The draft then reads the IDs from the file, checks the ID validity and
* continues as normal.
*
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>

#define ALIGN_COLUMNS	9	//check cards/draft.c

static GtkWidget *window = NULL;
static GtkTreeModel *model = NULL;

static char rarity = -1;
static char sequence =0;
static guint timeout = 0;
static int sets[3];

enum
{
  COLUMN_EXPANSIONS,
  COLUMN_SET_NUM,
  COLUMN_SELECT_1,
  COLUMN_SELECT_2,
  COLUMN_SELECT_3,
  NUM_COLUMNS
};

static int num_valid_expansions = 0;
static const char** all_set_names = NULL;
static gchar data[];


static void destroy(GtkWidget *widget, gpointer data)
{
	sequence++;
//    gtk_main_quit();
	
	gtk_widget_destroy (window);
	window = NULL;
	
}

static gboolean window_closed (GtkWidget *widget,
               GdkEvent  *event,
               gpointer   user_data)
{
  model = NULL;
//  window = NULL;
 
gtk_widget_destroy (window);
		window = NULL;
  
  if (timeout != 0)
    {
      g_source_remove (timeout);
      timeout = 0;
    }
  return FALSE;
}

void rarity_selected(GtkWidget *widget, gpointer data) 
{
	
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)) )
    {
        GSList *group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (widget));
		rarity = g_slist_index (group, widget);
        g_print ("Index = %d..... \n", rarity);
    }
}

static int get_rarity(void) 		
{

   if (rarity == -1)
		printf("You have not selected expansion set for all packs \n");
	else
	{
	 FILE *file = fopen("draft_selected_sets.txt", "w");
	 fprintf(file,"%d\n", rarity);	//-7 to be in accordance with expansions.h
	 fclose(file);
	 printf("CONTINUE TO select draft sets,	rarity=%d...\n", rarity );
	}

//printf("CONTINUE TO DRAFT \n");
//gtk_widget_destroy (window);

return 0;
}

//static const char* get_set_names(void)
static void get_set_names(void)
{
int setnum = 0;
  
printf("get_set_names............................... \n");
  
  if (!all_set_names)
	{
	  FILE* f = fopen("Menus.txt", "r");
	  //ASSERT(f && "Could not open Menus.txt");

	  char buf[1000], *p;
	  do
		{
		  p = fgets(buf, 1000, f);
		  //ASSERT(p && "Could not find @EXPANSIONNAMES in Menus.txt");
		} while (strcmp(buf, "@EXPANSIONNAMES\n"));

	  p = fgets(buf, 1000, f);
	  //ASSERT(p && "Could not read number of expansions from Menus.txt");

	  num_valid_expansions = atoi(buf);
	  //ASSERT(num_valid_expansions > 0 && "Could not parse number of expansions from Menus.txt");
	  printf("num_valid_expansions =%d \n", num_valid_expansions);

	  all_set_names = (const char**)malloc(num_valid_expansions * sizeof(const char*));
	  //ASSERT(all_set_names && "Out of memory");

	  int i;
	  for (i = 0; i < num_valid_expansions; ++i)
		{
		  p = fgets(buf, 1000, f);
		  if (!p)
			{
			  //popup("Fatal", "Could not read expansion name #%d from Menus.txt", i);
			  abort();
			}

		  int l = strlen(buf);
		  if (l <= 1)
			{
			  //popup("Fatal", "Could not read expansion name #%d from Menus.txt", i);
			  abort();
			}
		  buf[l - 1] = 0;	// strip the \n

		  all_set_names[i] = strdup(buf);
//		  printf("all_set_names[%d] = %s \n", i, all_set_names[i]);
		}
//		printf("all_set_names = %d \n", G_N_ELEMENTS(all_set_names) );
	 fclose(f);
	}
  //ASSERT(setnum < num_valid_expansions);
//  return all_set_names[setnum];
  return;
}

static GtkTreeModel * create_model(void)
{
  gint i = 0;

  GtkListStore *store;
  GtkTreeIter iter;

  /* create list store */
  store = gtk_list_store_new (NUM_COLUMNS,
                              G_TYPE_STRING,
                              G_TYPE_UINT,
                              G_TYPE_BOOLEAN,
							  G_TYPE_BOOLEAN,
							  G_TYPE_BOOLEAN);

  /* add data to the list store */
  
  for (i = 0; i < num_valid_expansions; i++)
    {
      gtk_list_store_append (store, &iter);
      gtk_list_store_set (store, &iter,
                          COLUMN_EXPANSIONS, all_set_names[i],	  
                          COLUMN_SET_NUM, (i + ALIGN_COLUMNS),
                          COLUMN_SELECT_1, FALSE,
                          COLUMN_SELECT_2, FALSE,
                          COLUMN_SELECT_3, FALSE,						  
                          -1);
    }

  return GTK_TREE_MODEL (store);
}

static void
select_toggle1(GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
	GtkTreeModel *model = (GtkTreeModel *)data;
	GtkTreeIter  iter;
	static  GtkTreeIter prev_iter = 	{ 0, };

	GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
	gboolean selection;
	gint *column;
	gint set1 = 0;

	column = g_object_get_data (G_OBJECT (cell), "column");

	/* get toggled iter */
	gtk_tree_model_get_iter (model, &iter, path);
	gtk_tree_model_get (model, &iter, COLUMN_SELECT_1, &selection, -1);		//get the iter-column value
	//  gtk_tree_model_get (model, &iter, column, &selection, -1);

//	Uncheck prev_iter ,  if needed
	if ( prev_iter.stamp ==  0 ) {
		gtk_tree_model_get_iter (model, &prev_iter, path);
//		printf("select_toggle1:		&prev_iter  ==  0 \n");
	} 	else	{
		gtk_list_store_set (GTK_LIST_STORE (model), &prev_iter, COLUMN_SELECT_1, 0, -1);
		gtk_tree_model_get_iter (model, &prev_iter, path);
//		printf("select_toggle1:		&prev_iter  !=  0 \n");
	} 
	
  /* do something with the value */
	selection |= 1;	//  ^ 1: check radio button, 0: uncheck

 /* get the set*/ 
	sets[0] = -1;
	gtk_tree_model_get (model, &iter, COLUMN_SET_NUM, &sets[0], -1);
	printf("CONTINUE TO DRAFT,		set1=%d \n", sets[0]);
	
/* set new value */
gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_SELECT_1, selection, -1);
  
  /* clean up */
  gtk_tree_path_free (path);
}

static void
select_toggle2(GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
	GtkTreeModel *model = (GtkTreeModel *)data;
	GtkTreeIter  iter;
	static  GtkTreeIter prev_iter = 	{ 0, };

	GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
	gboolean selection;
	gint *column;

	column = g_object_get_data (G_OBJECT (cell), "column");

	/* get toggled iter */
	gtk_tree_model_get_iter (model, &iter, path);
	gtk_tree_model_get (model, &iter, COLUMN_SELECT_2, &selection, -1);

//	Uncheck prev_iter ,  if needed
	if ( prev_iter.stamp ==  0 ) {
		gtk_tree_model_get_iter (model, &prev_iter, path);
	} 	else	{
		gtk_list_store_set (GTK_LIST_STORE (model), &prev_iter, COLUMN_SELECT_2, 0, -1);
		gtk_tree_model_get_iter (model, &prev_iter, path);
	} 
	
  /* do something with the value */
	selection |= 1;	//  ^ 1: check radio button, 0: uncheck 

	/* set new value */
	gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_SELECT_2, selection, -1);

	/* get the set*/ 
	sets[1] = -1;
	gtk_tree_model_get (model, &iter, COLUMN_SET_NUM, &sets[1], -1);
	printf("CONTINUE TO DRAFT,		set2=%d \n", sets[1]);

	/* clean up */
	gtk_tree_path_free (path);
}

static void
select_toggle3(GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
	GtkTreeModel *model = (GtkTreeModel *)data;
	GtkTreeIter  iter;
	static  GtkTreeIter prev_iter = 	{ 0, };

	GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
	gboolean selection;
	gint *column;

	column = g_object_get_data (G_OBJECT (cell), "column");

	/* get toggled iter */
	gtk_tree_model_get_iter (model, &iter, path);
	gtk_tree_model_get (model, &iter, COLUMN_SELECT_3, &selection, -1);

//	Uncheck prev_iter ,  if needed
	if ( prev_iter.stamp ==  0 ) {
		gtk_tree_model_get_iter (model, &prev_iter, path);
	} 	else	{
		gtk_list_store_set (GTK_LIST_STORE (model), &prev_iter, COLUMN_SELECT_3, 0, -1);
		gtk_tree_model_get_iter (model, &prev_iter, path);
	} 
	
  /* do something with the value */
	selection |= 1;	//  ^ 1: check radio button, 0: uncheck 

	/* set new value */
	gtk_list_store_set (GTK_LIST_STORE (model), &iter, COLUMN_SELECT_3, selection, -1);

	/* get the set*/ 
	sets[2] = -1;
	gtk_tree_model_get (model, &iter, COLUMN_SET_NUM, &sets[2], -1);
	printf("CONTINUE TO DRAFT,		set3=%d \n", sets[2]);

	/* clean up */
	gtk_tree_path_free (path);
}

static void
add_columns (GtkTreeView *treeview)
{
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GtkTreeModel *model = gtk_tree_view_get_model (treeview);


   /* column for Expansion names  */
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("Expansions",
                                                     renderer,
                                                     "text",
                                                     COLUMN_EXPANSIONS,
                                                     NULL);
  gtk_tree_view_column_set_sort_column_id (column, COLUMN_EXPANSIONS);
  gtk_tree_view_append_column (treeview, column);

  /* column for Expansion numbers */
  renderer = gtk_cell_renderer_text_new ();
g_object_set (G_OBJECT (renderer), "foreground", "Orange", "foreground-set", TRUE, NULL);  
  column = gtk_tree_view_column_new_with_attributes ("Set number",
                                                     renderer,
                                                     "text",
                                                     COLUMN_SET_NUM,
                                                     NULL);
  gtk_tree_view_column_set_sort_column_id (column, COLUMN_SET_NUM);
  gtk_tree_view_append_column (treeview, column);
 
  /* column for Set1 selection */
   GSList *group1;
  renderer = gtk_cell_renderer_toggle_new ();
  gtk_cell_renderer_toggle_set_radio ( (GtkCellRendererToggle *) renderer, TRUE);

  g_signal_connect (renderer, "toggled", G_CALLBACK (select_toggle1), model);

  column = gtk_tree_view_column_new_with_attributes ("Pack 1",
                                                     renderer,
                                                     "active", COLUMN_SELECT_1,
                                                     NULL);

  /* set this column to a fixed sizing (of 50 pixels) */
  gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
  gtk_tree_view_column_set_fixed_width (GTK_TREE_VIEW_COLUMN (column), 50);
  gtk_tree_view_append_column (treeview, column);
//	gtk_tree_view_append_column(treeview, GTK_TREE_VIEW_COLUMN(column));

	
  /* column for Set2 selection */
  renderer = gtk_cell_renderer_toggle_new ();
  gtk_cell_renderer_toggle_set_radio ( GTK_CELL_RENDERER_TOGGLE(renderer), TRUE);
 
  g_signal_connect (renderer, "toggled", G_CALLBACK (select_toggle2), model);
  column = gtk_tree_view_column_new_with_attributes ("Pack 2",
                                                     renderer,
                                                     "active", COLUMN_SELECT_2,
                                                     NULL);

  /* set this column to a fixed sizing (of 50 pixels) */
  gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
  gtk_tree_view_column_set_fixed_width (GTK_TREE_VIEW_COLUMN (column), 50);
  gtk_tree_view_append_column (treeview, column);

  /* column for Set3 selection */
  renderer = gtk_cell_renderer_toggle_new ();
  gtk_cell_renderer_toggle_set_radio ( (GtkCellRendererToggle *) renderer, TRUE);
 
  g_signal_connect (renderer, "toggled", G_CALLBACK (select_toggle3), model);
  column = gtk_tree_view_column_new_with_attributes ("Pack 3",
                                                     renderer,
                                                     "active", COLUMN_SELECT_3,
                                                     NULL);

  /* set this column to a fixed sizing (of 50 pixels) */
  gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
  gtk_tree_view_column_set_fixed_width (GTK_TREE_VIEW_COLUMN (column), 50);
  gtk_tree_view_append_column (treeview, column);

}


void create_radio_buttons (void) {

//	http://www.gtk.org/api/2.6/gtk/GtkRadioButton.html

  GtkWidget *window, *radio1, *radio2, *radio3, *box, *entry;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;


   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   box = gtk_vbox_new (TRUE, 2);

   /* Create a radio button with a GtkEntry widget */
//   radio1 = gtk_radio_button_new (NULL);
   radio1 = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (radio1),
							"Ignore Rarity");
   
   /* Create a radio button with a label */
   radio2 = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (radio1),
							"Enforce Rarity");
   radio3 = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (radio1),
							"Singleton Draft");							


  /* column for Set1 selection */
/*
  GSList *group1;
  renderer = gtk_cell_renderer_toggle_new ();
  gtk_cell_renderer_toggle_set_radio ( (GtkCellRendererToggle *) renderer, TRUE);
  g_signal_connect (renderer, "toggled", G_CALLBACK (select_toggle1), model);
*/
   
   /* Pack them into a box, then show all the widgets */
   gtk_box_pack_start (GTK_BOX (box), radio1, TRUE, FALSE, 2);
   gtk_box_pack_start (GTK_BOX (box), radio2, TRUE, TRUE, 2);
   gtk_box_pack_start (GTK_BOX (box), radio3, TRUE, TRUE, 2);   
   gtk_container_add (GTK_CONTAINER (window), box);
   gtk_widget_show_all (window);

  gtk_main();
   
   return;
}


static int write_selected (void) 		
{

   if (sets[0] == -1 || sets[1] == -1 || sets[2] == -1)
		printf("You have not selected expansion set for all packs \n");
	else
	{
	 FILE *file = fopen("draft_selected_sets.txt", "w+");
	 fprintf(file,"%d\n%d\n%d\n", sets[0], sets[1], sets[2]);	//-7 to be in accordance with expansions.h
	 fclose(file);
	 printf("CONTINUE TO DRAFT BUTTON,		set1=%d,	set2=%d,	set3=%d \n", sets[0], sets[1], sets[2] );
	}

//printf("CONTINUE TO DRAFT \n");

return 0;
}


static void read_selected(void)
{
static int selected_sets[3];
  
printf("read_selected............................... \n");  

for (char i=0; i<3; i++)
	selected_sets[i]= 0;
	
//  if (!selected_sets)
//	{
	  FILE* f = fopen("draft_selected_sets.txt", "r");
	  //ASSERT(f && "Could not open draft_selected_sets.txt");

	  char buf[200], *p;
/*
	  do
		{
		  p = fgets(buf, 200, f);
		  //ASSERT(p && "Could not find @EXPANSIONNAMES in Menus.txt");
		} while (strcmp(buf, "@EXPANSIONNAMES\n"));
*/

	  char i;
	  for (i = 0; i < 3; ++i)
		{
		  selected_sets[i] = 0;
		  p = fgets(buf, 200, f);
		  if (!p)
			{
				printf("Fatal, Could not read selected_set[%d] from draft_selected_sets.txt", i);
			  //popup("Fatal", "Could not read expansion name #%d from draft_selected_sets.txt", i);
			  abort();
			}

		  int l = strlen(buf);
		  if (l <= 1)
			{
				printf("Fatal, Could not read selected_set[%d] from draft_selected_sets.txt, l <= 1 ", i);
				//popup("Fatal", "Could not read expansion name #%d from draft_selected_sets.txt", i);
			  abort();
			}
		  buf[l - 1] = 0;	// strip the \n

		  selected_sets[i] = atoi(buf);		  
		  printf("read_selected:.......selected_sets[%d] = %d \n", i, selected_sets[i]);
		}

	 fclose(f);
//	}
//ASSERT(setnum < num_valid_expansions);
//  return all_set_names[setnum];

  return;
}


void rarity_selection(void)
{

	GtkWidget *hbox;	
	GtkWidget *label;
	GtkWidget *button;
	
	GtkWidget *window1 = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title (GTK_WINDOW (window1), "GtkListStore demo");
	gtk_container_set_border_width (GTK_CONTAINER (window1), 8);


	g_signal_connect(window1, "destroy", G_CALLBACK(destroy), NULL);

	GtkWidget *vbox = gtk_vbox_new(TRUE, 5);
	gtk_container_add(GTK_CONTAINER(window1), vbox);

		label = gtk_label_new ("Select Expansion sets for draft");
		gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);	
	
	GtkWidget *radiobutton;

	radiobutton = gtk_radio_button_new_with_label(NULL, "Singleton Draft");
//	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobutton), TRUE);
	g_signal_connect(radiobutton, "toggled", G_CALLBACK(rarity_selected), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), GTK_WIDGET(radiobutton), FALSE, FALSE, 0);

	GSList *group;
//	group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radiobutton));

	radiobutton = gtk_radio_button_new_with_label(gtk_radio_button_get_group(GTK_RADIO_BUTTON(radiobutton)), "Enforce Rarity");
	g_signal_connect(radiobutton, "toggled", G_CALLBACK(rarity_selected), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), GTK_WIDGET(radiobutton), FALSE, FALSE, 0);

	radiobutton = gtk_radio_button_new_with_label(gtk_radio_button_get_group(GTK_RADIO_BUTTON(radiobutton)), "Ignore Rarity");
	g_signal_connect(radiobutton, "toggled", G_CALLBACK(rarity_selected), NULL);
//	g_signal_connect(radiobutton, "toggled", G_CALLBACK(rarity_button_toggled), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), GTK_WIDGET(radiobutton), FALSE, FALSE, 0);

      hbox = gtk_hbox_new(TRUE, 3);
      gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

      button = gtk_button_new_with_label ("CONTINUE");
	  g_signal_connect(button, "clicked", G_CALLBACK(get_rarity), NULL);
	  //g_signal_connect (button, "clicked",G_CALLBACK (write_selected));

      gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

		/* Add a "close" button to the bottom of the dialog */
	button = gtk_button_new_with_label ("CLOSE");	
	g_signal_connect(button, "clicked", G_CALLBACK(window_closed), NULL);
//	window_closed , destroy
	

	gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);
		
    gtk_window_set_default_size (GTK_WINDOW (window1), 130, 100);
	gtk_widget_show_all(window1);

	
//return window;
return;
}


GtkWidget * do_list_store (GtkWidget *do_widget)
{

//	GtkWidget *window;

//gtk_init(&argc, &argv);

	if (!window)
	{


		GtkWidget *vbox;
		GtkWidget *hbox;
		GtkWidget *label;                       
		GtkWidget *sw;                        
		GtkWidget *treeview;                 

		GtkWidget *button_close;          
		GtkWidget *button;                   

		/* create window, etc */																																			
		window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title (GTK_WINDOW (window), "GtkListStore demo");
		gtk_container_set_border_width (GTK_CONTAINER (window), 8);
		g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK(gtk_main_quit), NULL);

		vbox = gtk_vbox_new (FALSE, 8);
		gtk_container_add (GTK_CONTAINER (window), vbox);

		label = gtk_label_new ("Select Expansion sets for draft");
		gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);

		sw = gtk_scrolled_window_new (NULL, NULL);
		gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
									   GTK_SHADOW_ETCHED_IN);
		gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
								  GTK_POLICY_AUTOMATIC,		//NEVER
								  GTK_POLICY_AUTOMATIC);
		gtk_box_pack_start (GTK_BOX (vbox), sw, TRUE, TRUE, 0);

		/* create tree model */
		model = create_model ();

		/* create tree view */
		treeview = gtk_tree_view_new_with_model (model);
		gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), TRUE);
		//      gtk_tree_view_set_search_column (GTK_TREE_VIEW (treeview), COLUMN_DESCRIPTION);

		/* add columns to the tree view */
		add_columns (GTK_TREE_VIEW (treeview));
		
		g_object_unref (model);

		gtk_container_add (GTK_CONTAINER (sw), treeview);

      /* some buttons */
      hbox = gtk_hbox_new (TRUE, 4);
      gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

      button = gtk_button_new_with_label ("CONTINUE");
      g_signal_connect (button, "clicked",
                        G_CALLBACK (write_selected), treeview);
      gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

    /* Add a "close" button to the bottom of the dialog */
    button = gtk_button_new_with_label ("CLOSE");

    g_signal_connect (button, "clicked",
                        G_CALLBACK (window_closed), treeview);
      gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);
							   
		/* finish & show the  window*/
    gtk_window_set_default_size (GTK_WINDOW (window), 530, 400);		
//		g_signal_connect (window, "delete-event", G_CALLBACK (window_closed), NULL);
		
	}
	
	//	gtk_widget_show_all (window);

	if (!gtk_widget_get_visible (window))
		gtk_widget_show_all (window);
	else
    {
		gtk_widget_destroy (window);
		window = NULL;
    }
	
//	 gtk_main();
	
  return window;
}

void threadfunc(void) {
    int msec = 0;
    while (1) {
        msec++;
        g_usleep(1000);	//1000
        g_idle_add((GSourceFunc)create_radio_buttons, NULL);
    }
} 


int main (int argc, char **argv)
{

 // empty out sets
 for(char j=0;j<3;j++){
	sets[j]= -1;
 }
			
 gtk_init(&argc, &argv);

 get_set_names();
 do_list_store(window);

 read_selected();

 gtk_main();

  return 0;
}
